library delphi6;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Windows,
  Dialogs,
  Unit1 in 'Unit1.pas' {Form1};

{$R *.res}

function  ShowDllForm:Integer; stdcall;
var
    Form : TForm1;
begin
  Form := TForm1.Create(nil);
  Result := Form.ShowModal;
  Form.Free;
end;

procedure RecvString(p:Pchar)stdcall;
begin
    ShowMessage(p);
end;

function  GetString(p:Pchar; sz:Integer):Integer; stdcall;
var
    s: AnsiString;
    h: Integer;
begin
    s := 'this is my test';
    s := s + ' and some more test';
    h := Length(s);
    if sz > h then begin
        CopyMemory(p, PChar(s), Length(s)+1);
    end;
    Result := Length(s);
end;

procedure CallBack(lpfn: Pointer);stdcall;
type
   CExport = procedure; stdcall;
var
   MyCExport: CExport absolute lpfn;
begin
        if Assigned (MyCExport) then
                MyCExport()
        else
                ShowMessage('did you pass a 0 in?');
end;

procedure CallExport(); stdcall;
type
   CExport = procedure; stdcall;
var
   dllHandle : cardinal;
   MyCExport : CExport;
begin
   dllHandle := GetModuleHandle('loader.exe') ;

   if dllHandle <> 0 then
   begin
        @MyCExport := GetProcAddress(dllHandle, 'MyCExport') ;
        if Assigned (MyCExport) then
                MyCExport()
        else
                ShowMessage('Could not getprocaddress');
   end
   else
        ShowMessage('Could not getmodulehandle');

end;

Exports
    ShowDllForm,
    RecvString,
    GetString,
    CallBack,
    CallExport;

begin

end.



